/* -*-C++-*-
 * ###################################################################
 *	EvoX - evolution in	complex	systems
 * 
 *	FILE: "Cpplplot_Init.cpp"
 *					  created: 19/7/96 {5:12:58 pm} 
 *				  last update: 30/8/98 {12:13:17 pm} 
 *	Author:	Vince Darley
 *	E-mail:	<vince@das.harvard.edu>
 *	  mail:	Division of	Applied	Sciences, Harvard University
 *			Oxford Street, Cambridge MA	02138, USA
 *	   www:	<http://www.fas.harvard.edu/~darley/>
 *	
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  23/7/96  VMD 1.0 original
 * ###################################################################
 */

#include "cpptcl.h"
#include "pltcl_stream.h"

extern "C" Plplot_Init(Tcl_Interp*);

/// Here's the C++ package init procedure
int Cpptcl_InitFunction(Cpplplot_Init)  {
	interp.PkgRequire("Cpptcl");
	if (Plplot_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if(interp.PkgRequire("Plplot","4.99") == NULL) {
	    return TCL_ERROR;
	}
	if(interp.PkgRequire("Matrix") == NULL)
		return TCL_ERROR;

	Cpptcl_Object(pltcl_stream, tcl_base);
	// Tell Tcl about this package
	interp.PkgProvide("Cpplplot","4.99");
	// Everything went ok, so return
	return TCL_OK;	
}
