## -*-Tcl-*-
 # ###################################################################
 # 
 #	FILE: "plapi.tcl"
 #									  created: 19/7/96 {3:32:34 pm}	
 #								  last update: 14/10/97 {10:51:26 am}	am}	
 #	Author:	Vince Darley
 #	E-mail:	<vince@das.harvard.edu>
 #	  mail:	Division of	Applied	Sciences, Harvard University
 #			Oxford Street, Cambridge MA	02138, USA
 #	   www:	<http://www.fas.harvard.edu/~darley/>
 #	
 #	File to autogenerate the plplot API for use with the Tcl package
 #	'Cpptcl' written by Vince Darley, and available from:
 # 
 #  	http://www.fas.harvard.edu/~darley/EvoXandCpptcl.html
 # 
 #  Why is this cool?  It allows on-line help, type-checking,
 #  command completion, ...
 # 
 #  Also the code generated is _very_ readable, and the generation
 #  system is more powerful than the old one.
 # 
 #  modified by  rev reason
 #  -------- --- --- -----------
 #  22/7/96  VMD 1.0 original
 # ###################################################################
 ##

# Advance to subpage "page", or to the next one if "page" = 0.

pltclcmd {{Advance to subpage "page", or to the next one if "page" = 0.} 
{pladv void}
{page	PLINT Def: 0}
}

# This functions similarly to plbox() except that the origin of the axes
# is placed at the user-specified point (x0, y0).

pltclcmd {{This functions similarly to plbox() except that the origin of the axes is placed at the user-specified point (x0, y0).} 
{plaxes void}
{x0	PLFLT}
{y0	PLFLT}
{xopt	const char *}
{xtick	PLFLT}
{nxsub	PLINT}
{yopt	const char *}
{ytick	PLFLT}
{nysub	PLINT}
}

# Plot a histogram using x to store data values and y to store frequencies

pltclcmd {{Plot a histogram using x to store data values and y to store frequencies} 
{plbin void}
{nbin	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{center	PLINT}
}

# Start new page.  Should only be used with pleop().

pltclcmd {{Start new page.  Should only be used with pleop().} 
{plbop void}
}

# This draws a box around the current viewport.

pltclcmd {{This draws a box around the current viewport.} 
{plbox void}
{xopt	const char *}
{xtick	PLFLT}
{nxsub	PLINT}
{yopt	const char *}
{ytick	PLFLT}
{nysub	PLINT}
}

# This is the 3-d analogue of plbox().

pltclcmd {{This is the 3-d analogue of plbox().} 
{plbox3 void}
{xopt	const char *}
{xlabel	const char *}
{xtick	PLFLT}
{nsubx	PLINT}
{yopt	const char *}
{ylabel	const char *}
{ytick	PLFLT}
{nsuby	PLINT}
{zopt	const char *}
{zlabel	const char *}
{ztick	PLFLT}
{nsubz	PLINT}
}

# Set color, map 0.  Argument is integer between 0 and 15.

pltclcmd {{Set color, map 0.  Argument is integer between 0 and 15.} 
{plcol void}
{icol0	PLINT}
}

# Set color, map 1.  Argument is a float between 0. and 1.

pltclcmd {{Set color, map 1.  Argument is a float between 0. and 1.} 
{plcol void}
{colour1	PLFLT}
}

# Converts input values from relative device coordinates to relative plot
# coordinates.

pltclcmd {{Converts input values from relative device coordinates to relative plot coordinates.} 
{pldid2pc void}
{xmin	PLFLT&}
{ymin	PLFLT&}
{xmax	PLFLT&}
{ymax	PLFLT&}
}

# Converts input values from relative plot coordinates to relative
# device coordinates.

pltclcmd {{Converts input values from relative plot coordinates to relative device coordinates.} 
{pldip2dc void}
{xmin	PLFLT&}
{ymin	PLFLT&}
{xmax	PLFLT&}
{ymax	PLFLT&}
}

# End a plotting session for all open streams.

## 
 # pltclcmd	{{plend	void}
 # }
 ##

# End a plotting session for the current stream only.

## 
 # pltclcmd	{{plend1 void}
 # }
 ##

# Simple interface for defining viewport and window.

pltclcmd {{Simple interface for defining viewport and window.} 
{plenv void}
{xmin	PLFLT}
{xmax	PLFLT}
{ymin	PLFLT}
{ymax	PLFLT}
{just	PLINT}
{axis	PLINT}
}

# End current page.  Should only be used with plbop().

pltclcmd {{End current page.  Should only be used with plbop().} 
{pleop void}
}

# Plot horizontal error bars (xmin(i),y(i)) to (xmax(i),y(i))

pltclcmd {{Plot horizontal error bars (xmin(i),y(i)) to (xmax(i),y(i))} 
{plerrx void}
{n	PLINT}
{xmin	TclMatFloat}
{xmax	TclMatFloat}
{y	TclMatFloat}
}

# Plot vertical error bars (x,ymin(i)) to (x(i),ymax(i))

pltclcmd {{Plot vertical error bars (x,ymin(i)) to (x(i),ymax(i))} 
{plerry void}
{n	PLINT}
{x	TclMatFloat}
{ymin	TclMatFloat}
{ymax	TclMatFloat}
}

# Advance to the next family file on the next new page

pltclcmd {{Advance to the next family file on the next new page} 
{plfamadv void}
}

# Pattern fills the polygon bounded by the input points.

pltclcmd {{Pattern fills the polygon bounded by the input points.} 
{plfill void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
}

# Flushes the output stream.  Use sparingly, if at all.

pltclcmd {{Flushes the output stream.  Use sparingly, if at all.} 
{plflush void}
}

# Sets the global font flag to 'ifont'.

pltclcmd {{Sets the global font flag to 'ifont'.} 
{plfont void}
{ifont	PLINT}
}

# Load specified font set.

pltclcmd {{Load specified font set.} 
{plfontld void}
{fnt	PLINT}
}

# Get character default height and current (scaled) height.

pltclcmd {{Get character default height and current (scaled) height.} 
{plgchr void}
{def	PLFLT&}
{ht	PLFLT&}
}

# Returns 8 bit RGB values for given color from color map 0.

pltclcmd {{Returns 8 bit RGB values for given color from color map 0.} 
{plgcol0 void}
{icol0	PLINT}
{r	PLINT&}
{g	PLINT&}
{b	PLINT&}
}

# Returns the background color by 8 bit RGB value.
# Will the autogenerated one produce useful values in Tcl ???
# Can this be implemented using PLINT& ???

# void
# c_plgcolbg(PLINT *r, PLINT *g, PLINT *b);

# Retrieve current window into device space.

pltclcmd {{Retrieve current window into device space.} 
{plgdidev void}
{mar	PLFLT&}
{aspect	PLFLT&}
{jx	PLFLT&}
{jy	PLFLT&}
}

# Get plot orientation .

pltclcmd {{Get plot orientation .} 
{plgdiori void}
{rot	PLFLT&}
}

# Retrieve current window into plot space.

pltclcmd {{Retrieve current window into plot space.} 
{plgdiplt void}
{xmin	PLFLT&}
{ymin	PLFLT&}
{xmax	PLFLT&}
{ymax	PLFLT&}
}

# Get family file parameters.

pltclcmd {{Get family file parameters.} 
{plgfam void}
{fam	PLINT&}
{num	PLINT&}
{bmax	PLINT&}
}

# Get output device parameters.

pltclcmd {{Get output device parameters.} 
{plgpage void}
{xp	PLFLT&}
{yp	PLFLT&}
{xleng	PLINT&}
{yleng	PLINT&}
{xoff	PLINT&}
{yoff	PLINT&}
}

# Switches to graphics screen.

pltclcmd {{Switches to graphics screen.} 
{plgra void}
}

# Get subpage boundaries in absolute coordinates.

pltclcmd {{Get subpage boundaries in absolute coordinates.} 
{plgspa void}
{xmin	PLFLT&}
{xmax	PLFLT&}
{ymin	PLFLT&}
{ymax	PLFLT&}
}

# Get current stream number.
# NOTE: Providing this feature from Tcl will finally provide a
# reliable mechanism for binding a C++ plstream object to a Tk plframe
# widget.  Query the frame for it's stream id, then pass this to the
# C++ side and use it to initialize the plstream object.
## 
 # 
 # pltclcmd	{{plgstrm void}
 # {strm   PLINT&}
 # }
 ##

# Get the current library version number.

pltclcmd {{Get the current library version number.} 
{plgver void}
{ver	char *}
}

# Get x axis labeling parameters.

pltclcmd {{Get x axis labeling parameters.} 
{plgxax void}
{digmax	PLINT&}
{digits	PLINT&}
}

# Get y axis labeling parameters.

pltclcmd {{Get y axis labeling parameters.} 
{plgyax void}
{digmax	PLINT&}
{digits	PLINT&}
}

# Get z axis labeling parameters.

pltclcmd {{Get z axis labeling parameters.} 
{plgzax void}
{digmax	PLINT&}
{digits	PLINT&}
}

# Draws a histogram of n values of a variable in array data[0..n-1].
# pltclgen not able to handle Tcl Matricies yet.

pltclcmd {{Draws a histogram of n values of a variable in array data[0..n-1]. pltclgen not able to handle Tcl Matricies yet.} 
{plhist void}
{n	PLINT}
{data	TclMatFloat}
{datmin	PLFLT}
{datmax	PLFLT}
{nbin	PLINT}
{oldwin	PLINT}
}

# Set current color (map 0) by hue, lightness, and saturation.

pltclcmd {{Set current color (map 0) by hue, lightness, and saturation.} 
{plhls void}
{h	PLFLT}
{l	PLFLT}
{s	PLFLT}
}

# Initializes PLplot, using preset or default options.

pltclcmd {{Initializes PLplot, using preset or default options.} 
{plinit void}
}

# Draws a line segment from (x1, y1) to (x2, y2).

pltclcmd {{Draws a line segment from (x1, y1) to (x2, y2).} 
{pljoin void}
{x1	PLFLT}
{y1	PLFLT}
{x2	PLFLT}
{y2	PLFLT}
}

# Simple routine for labelling graphs.

pltclcmd {{Simple routine for labelling graphs.} 
{pllab void}
{xlabel	const char *}
{ylabel	const char *}
{tlabel	const char *}
}

# sets the position of the light source

pltclcmd {{sets the position of the light source} 
{pllightsource void}
{x PLFLT}
{y PLFLT}
{z PLFLT}
}

# Draws line segments connecting a series of points.
# The original tclAPI.c version of this had a defaultable n capability,
# which we don't have...

pltclcmd {{Draws line segments connecting a series of points.}
{plline void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
}

# Draws a line in 3 space.
# pltclgen...

pltclcmd {{Draws a line in 3 space. pltclgen...} 
{plline3 void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{z	TclMatFloat}
}

# Set line style.

pltclcmd {{Set line style.} 
{pllsty void}
{lin	PLINT}
}

# Creates a new stream and makes it the default.

## 
 # pltclcmd	{{plmkstrm void}
 # {strm   PLINT&}
 # }
 ##

# Prints out "text" at specified position relative to viewport.

pltclcmd {{Prints out "text" at specified position relative to viewport.} 
{plmtex void}
{side	const char *}
{disp	PLFLT}
{pos	PLFLT}
{just	PLFLT}
{text	const char *}
}

# Set fill pattern directly.

pltclcmd {{Set fill pattern directly.} 
{plpat void}
{nlin	PLINT}
{inc	TclMatInt}
{del	TclMatInt}
}

# Plots array y against x for n points using ASCII code "code".
# The original tclAPI.c version of this had a defaultable n capability,
# which we don't have...

pltclcmd {{Plots array y against x for n points using ASCII code "code".}
{plpoin void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{code	PLINT}
}

# Draws a series of points in 3 space.

pltclcmd {{Draws a series of points in 3 space.} 
{plpoin3 void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{z	TclMatFloat}
{code	PLINT}
}

# Draws a polygon in 3 space.

pltclcmd {{Draws a polygon in 3 space.} 
{plpoly3 void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{z	TclMatFloat}
{draw	TclMatInt}
}

# Set the floating point precision (in number of places) in numeric labels.

pltclcmd {{Set the floating point precision (in number of places) in numeric labels.} 
{plprec void}
{setp	PLINT}
{precision	PLINT}
}

# Set fill pattern, using one of the predefined patterns.

pltclcmd {{Set fill pattern, using one of the predefined patterns.} 
{plpsty void}
{patt	PLINT}
}

# Prints out "text" at world cooordinate (x,y).

pltclcmd {{Prints out "text" at world cooordinate (x,y).} 
{plptex void}
{x	PLFLT}
{y	PLFLT}
{dx	PLFLT}
{dy	PLFLT}
{just	PLFLT}
{text	const char *}
}

# Replays contents of plot buffer to current device/file.

pltclcmd {{Replays contents of plot buffer to current device/file.} 
{plreplot void}
}

# Set line color by red, green, blue from  0. to 1.

pltclcmd {{Set line color by red, green, blue from  0. to 1.} 
{plrgb void}
{r	PLFLT}
{g	PLFLT}
{b	PLFLT}
}

# Set line color by 8 bit RGB values.

pltclcmd {{Set line color by 8 bit RGB values.} 
{plrgb1 void}
{r	PLINT}
{g	PLINT}
{b	PLINT}
}

# Set character height.

pltclcmd {{Set character height.} 
{plschr void}
{def	PLFLT}
{scale	PLFLT}
}

# Set number of colors in cmap 0.

pltclcmd {{Set number of colors in cmap 0.} 
{plscmap0n void}
{ncol0	PLINT}
}

# Set number of colors in cmap 1.

pltclcmd {{Set number of colors in cmap 1.} 
{plscmap1n void}
{ncol1	PLINT}
}

# Set color map 0 colors by 8 bit RGB values.

pltclcmd {{Set color map 0 colors by 8 bit RGB values.} 
{plscmap0 void}
{r	TclMatInt}
{g	TclMatInt}
{b	TclMatInt}
{ncol0	PLINT}
}

# Set color map 1 colors by 8 bit RGB values.

pltclcmd {{Set color map 1 colors by 8 bit RGB values.} 
{plscmap1 void}
{r	TclMatInt}
{g	TclMatInt}
{b	TclMatInt}
{ncol1	PLINT}
}

# Set color map 1 colors using a piece-wise linear relationship between
# intensity [0,1] (cmap 1 index) and position in HLS or RGB color space.

pltclcmd {{Set color map 1 colors using a piece-wise linear relationship between intensity [0,1] (cmap 1 index) and position in HLS or RGB color space.} 
{plscmap1l void}
{itype		PLINT}
{npts		PLINT}
{intensity	TclMatFloat}
{coord1		TclMatFloat}
{coord2		TclMatFloat}
{coord3		TclMatFloat}
{rev		TclMatInt}
}

# Set a given color from color map 0 by 8 bit RGB value.

pltclcmd {{Set a given color from color map 0 by 8 bit RGB value.} 
{plscol0 void}
{icol0	PLINT}
{r	PLINT}
{g	PLINT}
{b	PLINT}
}

# Set the background color by 8 bit RGB value.

pltclcmd {{Set the background color by 8 bit RGB value.} 
{plscolbg void}
{r	PLINT}
{g	PLINT}
{b	PLINT}
}

# Used to globally turn color output on/off.

pltclcmd {{Used to globally turn color output on/off.} 
{plscolor void}
{color	PLINT}
}

# Set the device (keyword) name

pltclcmd {{Set the device (keyword) name} 
{plsdev void}
{devnam	const char *}
}

# Get the device (keyword) name

pltclcmd {{Get the device (keyword) name} 
{plgdev void}
{devnam	char *}
}

# Set window into device space using margin, aspect ratio, and
# justification.

pltclcmd {{Set window into device space using margin, aspect ratio, and justification.} 
{plsdidev void}
{mar	PLFLT}
{aspect	PLFLT}
{jx	PLFLT}
{jy	PLFLT}
}

# Set up transformation from metafile coordinates.

pltclcmd {{Set up transformation from metafile coordinates.} 
{plsdimap void}
{dimxmin	PLINT}
{dimxmax	PLINT}
{dimymin	PLINT}
{dimymax	PLINT}
{dimxpmm	PLFLT}
{dimypmm	PLFLT}
}

# Set plot orientation, specifying rotation in units of pi/2.

pltclcmd {{Set plot orientation, specifying rotation in units of pi/2.} 
{plsdiori void}
{rot	PLFLT}
}

# Set window into plot space.

pltclcmd {{Set window into plot space.} 
{plsdiplt void}
{xmin	PLFLT}
{ymin	PLFLT}
{xmax	PLFLT}
{ymax	PLFLT}
}

# Set window into plot space incrementally (zoom).

pltclcmd {{Set window into plot space incrementally (zoom).} 
{plsdiplz void}
{xmin	PLFLT}
{ymin	PLFLT}
{xmax	PLFLT}
{ymax	PLFLT}
}

# Set the escape character for text strings.

pltclcmd {{Set the escape character for text strings.} 
{plsesc void}
{esc	char}
}

# Get the escape character for text strings.

pltclcmd {{Get the escape character for text strings.} 
{plgesc void}
{esc	char&}
}

# Set family file parameters

pltclcmd {{Set family file parameters} 
{plsfam void}
{fam	PLINT}
{num	PLINT}
{bmax	PLINT}
}

# Set the output file name.

pltclcmd {{Set the output file name.} 
{plsfnam void}
{fnam	const char *}
}

# Get the output file name.

pltclcmd {{Get the output file name.} 
{plgfnam void}
{fnam	char *}
}

# Get the current run level.

pltclcmd {{Get the current run level.} 
{plglevel void}
{level	PLINT&}
}

# Set up lengths of major tick marks.

pltclcmd {{Set up lengths of major tick marks.} 
{plsmaj void}
{def	PLFLT}
{scale	PLFLT}
}

# Set up lengths of minor tick marks.

pltclcmd {{Set up lengths of minor tick marks.} 
{plsmin void}
{def	PLFLT}
{scale	PLFLT}
}

# Set orientation.  Must be done before calling plinit.

pltclcmd {{Set orientation.  Must be done before calling plinit.} 
{plsori void}
{ori	PLINT}
}

# Set output device parameters.  Usually ignored by the driver.

pltclcmd {{Set output device parameters.  Usually ignored by the driver.} 
{plspage void}
{xp	PLFLT}
{yp	PLFLT}
{xleng	PLINT}
{yleng	PLINT}
{xoff	PLINT}
{yoff	PLINT}
}

# Set the pause (on end-of-page) status.

pltclcmd {{Set the pause (on end-of-page) status.} 
{plspause void}
{paus	PLINT}
}

# Set stream number.

pltclcmd {{Set stream number.}
{plsstrm void}
{strm PLINT}
}

# Set the number of subwindows in x and y.

pltclcmd {{Set the number of subwindows in x and y.} 
{plssub void}
{nx	PLINT}
{ny	PLINT}
}

# Set symbol height.

pltclcmd {{Set symbol height.} 
{plssym void}
{def	PLFLT}
{scale	PLFLT}
}

# Set up a new line style.

pltclcmd {{Set up a new line style.} 
{plstyl void}
{nms	PLINT}
{mark	TclMatInt}
{space	TclMatInt}
}

# Sets the edges of the viewport to the specified absolute coordinates.

pltclcmd {{Sets the edges of the viewport to the specified absolute coordinates.} 
{plsvpa void}
{xmin	PLFLT}
{xmax	PLFLT}
{ymin	PLFLT}
{ymax	PLFLT}
}

# Set x axis labeling parameters.

pltclcmd {{Set x axis labeling parameters.} 
{plsxax void}
{digmax	PLINT}
{digits	PLINT}
}

# Set y axis labeling parameters.

pltclcmd {{Set y axis labeling parameters.} 
{plsyax void}
{digmax	PLINT}
{digits	PLINT	Def: 0}
}

# Plots array y against x for n points using Hershey symbol "code".
# The original tclAPI.c version of this had a defaultable n capability,
# which we don't have...

pltclcmd {{Plots array y against x for n points using Hershey symbol "code".}
{plsym void}
{n	PLINT}
{x	TclMatFloat}
{y	TclMatFloat}
{code	PLINT}
}

# Set z axis labeling parameters.

pltclcmd {{Set z axis labeling parameters.} 
{plszax void}
{digmax	PLINT}
{digits	PLINT}
}

# Switches to text screen.

pltclcmd {{Switches to text screen.} 
{pltext void}
}

# Sets the edges of the viewport with the given aspect ratio, leaving
# room for labels.

pltclcmd {{Sets the edges of the viewport with the given aspect ratio, leaving room for labels.} 
{plvasp void}
{aspect	PLFLT}
}

# Creates the largest viewport of the specified aspect ratio that fits
# within the specified normalized subpage coordinates.

pltclcmd {{Creates the largest viewport of the specified aspect ratio that fits within the specified normalized subpage coordinates.} 
{plvpas void}
{xmin	PLFLT}
{xmax	PLFLT}
{ymin	PLFLT}
{ymax	PLFLT}
{aspect	PLFLT}
}

# Creates a viewport with the specified normalized subpage coordinates.

pltclcmd {{Creates a viewport with the specified normalized subpage coordinates.} 
{plvpor void}
{xmin	PLFLT}
{xmax	PLFLT}
{ymin	PLFLT}
{ymax	PLFLT}
}

# Defines a "standard" viewport with seven character heights for the
# left margin and four character heights everywhere else.

pltclcmd {{Defines a "standard" viewport with seven character heights for the left margin and four character heights everywhere else.} 
{plvsta void}
}

# Set up a window for three-dimensional plotting.

pltclcmd {{Set up a window for three-dimensional plotting.} 
{plw3d void}
{basex	PLFLT}
{basey	PLFLT}
{height	PLFLT}
{xmin0	PLFLT}
{xmax0	PLFLT}
{ymin0	PLFLT}
{ymax0	PLFLT}
{zmin0	PLFLT}
{zmax0	PLFLT}
{alt	PLFLT}
{az	PLFLT}
}

# Set pen width.

pltclcmd {{Set pen width.} 
{plwid void}
{width	PLINT}
}

# Set up world coordinates of the viewport boundaries (2d plots).

pltclcmd {{Set up world coordinates of the viewport boundaries (2d plots).} 
{plwind void}
{xmin	PLFLT}
{xmax	PLFLT}
{ymin	PLFLT}
{ymax	PLFLT}
}

###############################################################################
# The rest are kept in as reminders to how Tcl API might be improved 

# Draws a contour plot from data in f(nx,ny).  Is just a front-end to
# plfcont, with a particular choice for f2eval and f2eval_data. 

# void
# c_plcont(TclMatFloat*f, PLINT nx, PLINT ny, PLINT kx, PLINT lx,
# 	 PLINT ky, PLINT ly, TclMatFloatclevel, PLINT nlevel,
# 	 void (*pltr) (PLFLT, PLFLT, TclMatFloat, TclMatFloat, PLPointer),
# 	 PLPointer pltr_data);

# Draws a contour plot using the function evaluator f2eval and data stored
# by way of the f2eval_data pointer.  This allows arbitrary organizations
# of 2d array data to be used. 

# void
# plfcont(PLFLT (*f2eval) (PLINT, PLINT, PLPointer),
# 	PLPointer f2eval_data,
# 	PLINT nx, PLINT ny, PLINT kx, PLINT lx,
# 	PLINT ky, PLINT ly, TclMatFloatclevel, PLINT nlevel,
# 	void (*pltr) (PLFLT, PLFLT, TclMatFloat, TclMatFloat, PLPointer),
# 	PLPointer pltr_data);

# plot continental outline in world coordinates.

# void
# plmap(void (*mapform)(PLINT, TclMatFloat, TclMatFloat), char *type,
#       PLFLT minlong, PLFLT maxlong, PLFLT minlat, PLFLT maxlat);

# Plot the latitudes and longitudes on the background.

# void 
# plmeridians(void (*mapform)(PLINT, TclMatFloat, TclMatFloat), 
# 	    PLFLT dlong, PLFLT dlat,
# 	    PLFLT minlong, PLFLT maxlong, PLFLT minlat, PLFLT maxlat);

# Shade region.

# void 
# c_plshade(TclMatFloat*a, PLINT nx, PLINT ny, const char **defined,
# 	  PLFLT left, PLFLT right, PLFLT bottom, PLFLT top,
# 	  PLFLT shade_min, PLFLT shade_max,
# 	  PLINT sh_cmap, PLFLT sh_color, PLINT sh_width,
# 	  PLINT min_color, PLINT min_width,
# 	  PLINT max_color, PLINT max_width,
# 	  void (*fill) (PLINT, TclMatFloat, TclMatFloat), PLINT rectangular,
# 	  void (*pltr) (PLFLT, PLFLT, TclMatFloat, TclMatFloat, PLPointer),
# 	  PLPointer pltr_data);

# void 
# plshade1(TclMatFloata, PLINT nx, PLINT ny, const char *defined,
# 	 PLFLT left, PLFLT right, PLFLT bottom, PLFLT top,
# 	 PLFLT shade_min, PLFLT shade_max,
# 	 PLINT sh_cmap, PLFLT sh_color, PLINT sh_width,
# 	 PLINT min_color, PLINT min_width,
# 	 PLINT max_color, PLINT max_width,
# 	 void (*fill) (PLINT, TclMatFloat, TclMatFloat), PLINT rectangular,
# 	 void (*pltr) (PLFLT, PLFLT, TclMatFloat, TclMatFloat, PLPointer),
# 	 PLPointer pltr_data);

# void 
# plfshade(PLFLT (*f2eval) (PLINT, PLINT, PLPointer),
# 	 PLPointer f2eval_data,
# 	 PLFLT (*c2eval) (PLINT, PLINT, PLPointer),
# 	 PLPointer c2eval_data,
# 	 PLINT nx, PLINT ny, 
# 	 PLFLT left, PLFLT right, PLFLT bottom, PLFLT top,
# 	 PLFLT shade_min, PLFLT shade_max,
# 	 PLINT sh_cmap, PLFLT sh_color, PLINT sh_width,
# 	 PLINT min_color, PLINT min_width,
# 	 PLINT max_color, PLINT max_width,
# 	 void (*fill) (PLINT, TclMatFloat, TclMatFloat), PLINT rectangular,
# 	 void (*pltr) (PLFLT, PLFLT, TclMatFloat, TclMatFloat, PLPointer),
# 	 PLPointer pltr_data);

# Returns a list of file-oriented device names and their menu strings

# void
# plgFileDevs(char ***p_menustr, char ***p_devname, int *p_ndev);

# Set the function pointer for the keyboard event handler

# void
# plsKeyEH(void (*KeyEH) (PLGraphicsIn *, void *, int *), void *KeyEH_data);

# Set the function pointer for the (mouse) button event handler

# void
# plsButtonEH(void (*ButtonEH) (PLGraphicsIn *, void *, int *),
# 	    void *ButtonEH_data);

# Sets an optional user exit handler.

# void
# plsexit(int (*handler) (char *));

# Command line parsing utilities

# Clear internal option table info structure.

# void
# plClearOpts(void);

# Reset internal option table info structure.

# void
# plResetOpts(void);

# Merge user option table into internal info structure.

# int
# plMergeOpts(PLOptionTable *options, char *name, char **notes);

# Set the strings used in usage and syntax messages.

# void
# plSetUsage(char *program_string, char *usage_string);

# Process input strings, treating them as an option and argument pair.

# int
# plSetOpt(char *opt, char *optarg);

# Process options list using current options info.

# int
# plParseOpts(int *p_argc, char **argv, PLINT mode);

# Print usage & syntax message.

# void
# plOptUsage(void);

# Set the output file pointer

# void
# plgfile(FILE **p_file);

# Get the output file pointer

# void
# plsfile(FILE *file);

# Front-end to driver escape function.

# void
# pl_cmd(PLINT op, void *ptr);

# Return full pathname for given file if executable

# int 
# plFindName(char *p);

# Looks for the specified executable file according to usual search path.

# char *
# plFindCommand(char *fn);

# Gets search name for file by concatenating the dir, subdir, and file
# name, allocating memory as needed. 

# void
# plGetName(char *dir, char *subdir, char *filename, char **filespec);

# Functions for converting between HLS and RGB color space

# void
# plHLS_RGB(PLFLT h, PLFLT l, PLFLT s, TclMatFloatp_r, TclMatFloatp_g, TclMatFloatp_b);

# void
# plRGB_HLS(PLFLT r, PLFLT g, PLFLT b, TclMatFloatp_h, TclMatFloatp_l, TclMatFloatp_s);

# Wait for graphics input event and translate to world coordinates

# int
# plGetCursor(PLGraphicsIn *gin);

# Translates relative device coordinates to world coordinates. 

# int
# plTranslateCursor(PLGraphicsIn *gin);
