/* -*-C++-*-
 * ###################################################################
 *	EvoX - evolution in	complex	systems
 * 
 *	FILE: "cpx_args.h"
 *									  created: 19/7/96 {5:51:53 pm}	
 *								  last update: 21/10/97 {3:54:52 pm}	
 *	Author:	Vince Darley
 *	E-mail:	<vince@das.harvard.edu>
 *	  mail:	Division of	Applied	Sciences, Harvard University
 *			Oxford Street, Cambridge MA	02138, USA
 *	   www:	<http://www.fas.harvard.edu/~darley/>
 *	
 *	Description: 
 * 
 * 
 *	History
 * 
 *	modified by	 rev reason
 *	-------- --- --- -----------
 *	19/4/96	 VMD 1.0 original
 * ###################################################################
 */


#ifndef _EvoX_plcpp_args_
#define _EvoX_plcpp_args_

#include "cpptcl.h"
#define PLPLOT_MATRIX_CLASSES
#include "tclMatrix.h"

class TclMatInt;
class TclMatFloat;
class TclMatInt2;
class TclMatFloat2;

tcl_args& plcpp_matrix_read(tcl_args&, TclMatInt&, int dim);
tcl_args& plcpp_matrix_read(tcl_args&, TclMatFloat&, int dim);
tcl_args& operator >> (tcl_args& arg, TclMatInt& m);
tcl_args& operator >> (tcl_args& arg, TclMatInt2& m);
tcl_args& operator >> (tcl_args& arg, TclMatFloat& m);
tcl_args& operator >> (tcl_args& arg, TclMatFloat2& m);

inline tcl_args& operator >> (tcl_args& arg, TclMatInt& m) {
	return plcpp_matrix_read(arg,m,1);
}
inline tcl_args& operator >> (tcl_args& arg, TclMatFloat& m) {
	return plcpp_matrix_read(arg,m,1);
}
inline tcl_args& operator >> (tcl_args& arg, TclMatInt2& m) {
	return plcpp_matrix_read(arg,m,2);
}
inline tcl_args& operator >> (tcl_args& arg, TclMatFloat2& m) {
	return plcpp_matrix_read(arg,m,2);
}


#endif
